<template>
    <Message/>
    <n-card class="sub">
    <n-tabs
      class="card-tabs"
      default-value="signin"
      size="large"
      animated
      pane-wrapper-style="margin: 0 -4px"
      pane-style="padding-left: 4px; padding-right: 4px; box-sizing: border-box;"
    >
      <n-tab-pane name="signin" tab="Sign in">
        <n-form
      ref="formRef"
      :model="formValue"
      :rules="rules"
    >            <n-form-item-row label="Email" path="email">
            <n-input v-model:value="formValue.email" placeholder="Input Email" />
          </n-form-item-row>
          <n-form-item-row label="Password" path="password">
            <n-input v-model:value="formValue.password" placeholder="Input Password" type="password" />
          </n-form-item-row>
        </n-form>
        <n-button ghost color="#ff69b4" attr-type="submit" @click="login">
          Sign In
        </n-button>
      </n-tab-pane>
    </n-tabs>
  </n-card>
  </template>
  
  <script>
  import { defineComponent, ref } from "vue";
  import { NButton, NInput, NFormItem, NForm, NCard, NTabs, NTabPane, NFormItemRow} from 'naive-ui'
  import router from "../router";
  import { useUserStore } from "../store/user";
  import Message from "../components/Message.vue";
  
  export default defineComponent({
    setup() {
      const formRef = ref(null);
      const userStore = useUserStore();
      if (userStore.auth_token != null){
        router.push('/editor');
      }
      return {
        formRef,
        formValue: ref({
            email: "",
            password: ""
        }),
        rules: {
            email: {
              required: true,
              message: "Please input your email",
              trigger: "blur"
            },
            password: {
              required: true,
              message: "Please input your password",
              trigger: ["input", "blur"]
            }
          },
        async login() {
            try {
                await userStore.signIn(formRef.value.model.email, formRef.value.model.password);
                router.push('/editor');
            }
            catch (error) {
              window.$message.error(
                'Please check your credentials and try again.'
              )
            }
        },
      };
    },
    components: {
        Message,
        NButton,
        NInput,
        NForm,
        NFormItem,
        NCard,
        NTabs,
        NTabPane,
        NFormItemRow
        }
  });
  </script>